/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2024 KylinSoft  Co., Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */
#include <gtest/gtest.h>
#include <gtest/gtest-death-test.h>
#include "../../registeredSession/plugins/default/defaultinterface.h"

class DefaultInterfaceTest : public testing::Test
{
protected:
    static void SetUpTestSuite()
    {
       m_pDefaultInterface = new DefaultInterface();
    }

    static void TearDownTestSuite()
    {
       if (m_pDefaultInterface) {
           delete m_pDefaultInterface;
           m_pDefaultInterface = nullptr;
       }
    }

    static DefaultInterface* m_pDefaultInterface;
};

DefaultInterface *DefaultInterfaceTest::m_pDefaultInterface = nullptr;

TEST_F(DefaultInterfaceTest, getDefaultApp)
{
    QVariantList ret = m_pDefaultInterface->getDefaultApp("x-scheme-handler/http");
    ASSERT_GT(ret.size(), 0);
}

TEST_F(DefaultInterfaceTest, getAppList)
{
    QVariantList ret = m_pDefaultInterface->getAppList("x-scheme-handler/http");
    ASSERT_GT(ret.size(), 0);
}

TEST_F(DefaultInterfaceTest, setDefaultApp)
{
    bool ret = m_pDefaultInterface->setDefaultApp("kylin-music.desktop", "audio/x-vorbis+ogg");
    ASSERT_EQ(ret, true);
}

TEST_F(DefaultInterfaceTest, getSystemDefaultAppList)
{
    QMap<QString, QVariant> ret = m_pDefaultInterface->getSystemDefaultAppList();
    ASSERT_GT(ret.size(), 0);
}
